#cs ----------------------------------------------------------------------------
	AutoIt Version: 3.3.6.1
	Author:         Matwachich
	G-Engin (GEng) est un UDF qui permet de grer un affichage 2D
	avec AutoIt simplement.
	Il est bas sur GDI+.

	// Short Version by Dao Van Trong - Trong.LIVE //
#ce ----------------------------------------------------------------------------

#include <GDIPlus.au3>
#include <Array.au3>
#include <WinApi.au3>
;~ Opt("MustDeclareVars", 1) ;0=no, 1=require pre-declaration

Global Const $__GEng_PI = 4 * ATan(1), $__GEng_SpritesArrayUB = 40
Global $__GEng_hGui = -1, $__GEng_WinW = -1, $__GEng_WinH = -1, $__GEng_hBitmap = -1, $__GEng_hGraphic = -1, $__GEng_hBuffer = -1, $__GEng_hDC = -1, $__GEng_hCompatibleDC = -1
Global $__GEng_Images[1] = [0], $_Arrow, $_dbg_Arrow0 = 0, $_dbg_Arrow1, $_dbg_Arrow2, $_dbg_Arrow3, $_dbg_Arrow4, $_dbg_pen0 = 0, $_dbg_pen1, $_dbg_pen2, $_dbg_pen3, $_dbg_pen4
Global Enum $_gSpr_hBuffer, $_gSpr_iImg, $_gSpr_ImgX, $_gSpr_ImgY, $_gSpr_ImgW, $_gSpr_ImgH, $_gSpr_PosX, $_gSpr_PosY, $_gSpr_Width, $_gSpr_Height, $_gSpr_OriX, $_gSpr_OriY, $_gSpr_SpeedX, $_gSpr_SpeedY, $_gSpr_AccelX, $_gSpr_AccelY, $_gSpr_SpeedMax, $_gSpr_Innertie, $_gSpr_AngleDeg, $_gSpr_AngleRad, $_gSpr_AngleSpeed, $_gSpr_AngleAccel, $_gSpr_AngleSpeedMax, $_gSpr_AngleInnertie, $_gSpr_AngleOriDeg, $_gSpr_AngleOriRad, $_gSpr_AnimFrame, $_gSpr_AnimDelayMulti, $_gSpr_CollX, $_gSpr_CollY, $_gSpr_CollW, $_gSpr_CollH, $_gSpr_CollType, $_gSpr_MoveTimer, $_gSpr_AnimTimer, $_gSpr_ColorMatrix, $_gSpr_ColorMatrixPtr, $_gSpr_hImgAttrib, $_gSpr_UseColorMatrix, $_gSpr_Masse
Func _GEng_Start($sTitle, $iW, $iH, $iX = -1, $iY = -1, $iStyle = -1, $iExtStyle = -1)
	If __GEng_IsStarted() Then Return SetError(1, 0, 0)
	$__GEng_hGui = GUICreate($sTitle, $iW, $iH, $iX, $iY, $iStyle, $iExtStyle)
	If @error Then Return SetError(1, 0, 0)
	$__GEng_WinW = $iW
	$__GEng_WinH = $iH
	_GDIPlus_Startup()
	$__GEng_hGraphic = _GDIPlus_GraphicsCreateFromHWND($__GEng_hGui)
	$__GEng_hBitmap = _GDIPlus_BitmapCreateFromGraphics($__GEng_WinW, $__GEng_WinH, $__GEng_hGraphic)
	$__GEng_hBuffer = __GEng_GetBuffer()
	_GDIPlus_GraphicsSetInterpolationMode($__GEng_hGraphic, 7)
	DllCall($__g_hGDIPDll, "uint", "GdipSetTextRenderingHint", "handle", $__GEng_hBuffer, "int", 4)
	$__GEng_hDC = _WinAPI_GetDC($__GEng_hGui)
	$__GEng_hCompatibleDC = _WinAPI_CreateCompatibleDC($__GEng_hDC)
	GUISetState(@SW_SHOW, $__GEng_hGui)
	Return SetError(0, 0, 1)
EndFunc   ;==>_GEng_Start
Func _GEng_Shutdown()
	__GEng_Image_DisposeAll()
	_WinAPI_ReleaseDC($__GEng_hGui, $__GEng_hDC)
	_WinAPI_ReleaseDC($__GEng_hGui, $__GEng_hCompatibleDC)
	_WinAPI_DeleteDC($__GEng_hDC)
	_WinAPI_DeleteDC($__GEng_hCompatibleDC)
	_GDIPlus_GraphicsDispose($__GEng_hBuffer)
	_GDIPlus_BitmapDispose($__GEng_hBitmap)
	_GDIPlus_GraphicsDispose($__GEng_hGraphic)
	_GDIPlus_Shutdown()
	GUIDelete($__GEng_hGui)
EndFunc   ;==>_GEng_Shutdown
Func __GEng_GetBuffer()
	Local $hBuffer = _GDIPlus_ImageGetGraphicsContext($__GEng_hBitmap)
	_GDIPlus_GraphicsSetSmoothingMode($hBuffer, 7)
	Return $hBuffer
EndFunc   ;==>__GEng_GetBuffer
Func __GEng_IsStarted()
	If $__GEng_hGui = -1 Then Return 0
	Return 1
EndFunc   ;==>__GEng_IsStarted
Func _GEng_ImageLoad($sPath, $imgW = Default, $imgH = Default, $x = Default, $y = Default, $w = Default, $h = Default)
	Local $hImg = _GDIPlus_ImageLoadFromFile($sPath)
	If $hImg = -1 Then Return SetError(1, 0, 0)
	Return __GEng_ImageLoadDo($hImg, $imgW, $imgH, $x, $y, $w, $h)
EndFunc   ;==>_GEng_ImageLoad
Func __GEng_Image_IsImage($hImage)
	If Not IsArray($hImage) Then Return SetError(1, 0, 0)
	If UBound($hImage) <> 3 Then Return SetError(1, 0, 0)
	If $hImage[0] > $__GEng_Images[0] Then Return SetError(1, 0, 0)
	If $hImage[1] = -1 Or $hImage[2] = -1 Then Return SetError(1, 0, 0)
	Return 1
EndFunc   ;==>__GEng_Image_IsImage
Func __GEng_Image_DisposeAll()
	For $i = 1 To $__GEng_Images[0]
		_GDIPlus_ImageDispose($__GEng_Images[$i])
		_GDIPlus_BitmapDispose($__GEng_Images[$i])
	Next
EndFunc   ;==>__GEng_Image_DisposeAll
Func __GDIPlus_ImageGetThumbnail($hImg, $iW, $iH)
	Local $ret = DllCall($__g_hGDIPDll, "int", "GdipGetImageThumbnail", "hwnd", $hImg, "int", $iW, "int", $iH, "int*", 0, "ptr", 0, "ptr", 0)
	If @error Then
		Return SetError(1, 0, 0)
	EndIf
	Return SetError(0, 0, $ret[4])
EndFunc   ;==>__GDIPlus_ImageGetThumbnail
Func __GEng_ImageLoadDo($hImg, $imgW = Default, $imgH = Default, $x = Default, $y = Default, $w = Default, $h = Default)
	Local $width, $height
	If $x <> Default And $y <> Default And $w <> Default And $h <> Default Then
		$width = $w
		$height = $h
	Else
		$x = 0
		$y = 0
		$width = _GDIPlus_ImageGetWidth($hImg)
		$height = _GDIPlus_ImageGetHeight($hImg)
		$w = $width
		$h = $height
	EndIf
	Local $gContext, $newBmp, $gNewContext
	$gContext = _GDIPlus_ImageGetGraphicsContext($hImg)
	$newBmp = _GDIPlus_BitmapCreateFromGraphics($width, $height, $gContext)
	$gNewContext = _GDIPlus_ImageGetGraphicsContext($newBmp)
	_GDIPlus_GraphicsDrawImageRectRect($gNewContext, $hImg, $x, $y, $w, $h, 0, 0, $width, $height)
	_GDIPlus_GraphicsDispose($gNewContext)
	_GDIPlus_GraphicsDispose($gContext)
	_GDIPlus_ImageDispose($hImg)
	If $imgW <> Default And $imgH <> Default Then
		$hImg = __GDIPlus_ImageGetThumbnail($newBmp, $imgW, $imgH)
		_ArrayAdd($__GEng_Images, $hImg)
		_GDIPlus_BitmapDispose($newBmp)
		$width = $imgW
		$height = $imgH
	Else
		_ArrayAdd($__GEng_Images, $newBmp)
	EndIf
	$__GEng_Images[0] += 1
	Local $ret[3]
	$ret[0] = $__GEng_Images[0]
	$ret[1] = $width
	$ret[2] = $height
	Return $ret
EndFunc   ;==>__GEng_ImageLoadDo
Func _GEng_Sprite_Create($hImage = Default)
	Local $hSprite[$__GEng_SpritesArrayUB]
	__GEng_Sprite_InitArray($hSprite)
	If $hImage <> Default Then _GEng_Sprite_ImageSet($hSprite, $hImage)
	_GEng_Sprite_AnimRewind($hSprite)
	Return $hSprite
EndFunc   ;==>_GEng_Sprite_Create
Func _GEng_Sprite_ImageSet(ByRef $hSprite, ByRef $hImage, $x = Default, $y = Default, $w = Default, $h = Default)
	If Not __GEng_Sprite_IsSprite($hSprite) Then Return SetError(1, 0, 0)
	If Not __GEng_Image_IsImage($hImage) Then Return SetError(1, 0, 0)
	$hSprite[$_gSpr_iImg] = $hImage[0]
	If $x <> Default And $y <> Default And $w <> Default And $h <> Default Then
		$hSprite[$_gSpr_ImgX] = $x
		$hSprite[$_gSpr_ImgY] = $y
		$hSprite[$_gSpr_ImgW] = $w
		$hSprite[$_gSpr_ImgH] = $h
	Else
		$hSprite[$_gSpr_ImgX] = 0
		$hSprite[$_gSpr_ImgY] = 0
		$hSprite[$_gSpr_ImgW] = $hImage[1]
		$hSprite[$_gSpr_ImgH] = $hImage[2]
	EndIf
	If $hSprite[$_gSpr_Width] = 0 And $hSprite[$_gSpr_Height] = 0 Then _GEng_Sprite_SizeSet($hSprite, -1, -1)
	Return 1
EndFunc   ;==>_GEng_Sprite_ImageSet
Func _GEng_Sprite_Draw(ByRef $hSprite, $iCalculateMovements = 1)
	If Not __GEng_Sprite_IsSprite($hSprite) Then Return SetError(1, 0, 0)
	If Not __GEng_Sprite_ContainsImage($hSprite) Then Return SetError(1, 0, 0)
	If $iCalculateMovements Then _GEng_Sprite_Move($hSprite)
	Local $rotDeg = $hSprite[$_gSpr_AngleDeg]
	Local $rotRad = $hSprite[$_gSpr_AngleRad]
	Local $posX = $hSprite[$_gSpr_PosX], $posY = $hSprite[$_gSpr_PosY]
	Local $oriX = $hSprite[$_gSpr_OriX], $oriY = $hSprite[$_gSpr_OriY]
	Local $sizeW = $hSprite[$_gSpr_Width], $sizeH = $hSprite[$_gSpr_Height]
	Local $sheetX = $hSprite[$_gSpr_ImgX], $sheetY = $hSprite[$_gSpr_ImgY]
	Local $sheetW = $hSprite[$_gSpr_ImgW], $sheetH = $hSprite[$_gSpr_ImgH]
	Local $ret
	If $rotDeg = 0 Then
		If $hSprite[$_gSpr_UseColorMatrix] Then
			$ret = _GDIPlus_GraphicsDrawImageRectRectIA($__GEng_hBuffer, $__GEng_Images[$hSprite[$_gSpr_iImg]], $sheetX, $sheetY, $sheetW, $sheetH, $posX - $oriX, $posY - $oriY, $sizeW, $sizeH, $hSprite[$_gSpr_hImgAttrib])
		Else
			$ret = _GDIPlus_GraphicsDrawImageRectRect($__GEng_hBuffer, $__GEng_Images[$hSprite[$_gSpr_iImg]], $sheetX, $sheetY, $sheetW, $sheetH, $posX - $oriX, $posY - $oriY, $sizeW, $sizeH)
		EndIf
	Else
		Local $matrix = _GDIPlus_MatrixCreate()
		_GDIPlus_MatrixRotate($matrix, $rotDeg)
		_GDIPlus_MatrixTranslate($matrix, $posX * Cos(-$rotRad) - $posY * Sin(-$rotRad), $posX * Sin(-$rotRad) + $posY * Cos(-$rotRad))
		_GDIPlus_GraphicsSetTransform($hSprite[$_gSpr_hBuffer], $matrix)
		If $hSprite[$_gSpr_UseColorMatrix] Then
			$ret = _GDIPlus_GraphicsDrawImageRectRectIA($hSprite[$_gSpr_hBuffer], $__GEng_Images[$hSprite[$_gSpr_iImg]], $sheetX, $sheetY, $sheetW, $sheetH, -1 * $oriX, -1 * $oriY, $sizeW, $sizeH, $hSprite[$_gSpr_hImgAttrib])
		Else
			$ret = _GDIPlus_GraphicsDrawImageRectRect($hSprite[$_gSpr_hBuffer], $__GEng_Images[$hSprite[$_gSpr_iImg]], $sheetX, $sheetY, $sheetW, $sheetH, -1 * $oriX, -1 * $oriY, $sizeW, $sizeH)
		EndIf
		_GDIPlus_MatrixDispose($matrix)
	EndIf
	Return $ret
EndFunc   ;==>_GEng_Sprite_Draw
Func __GEng_Sprite_IsSprite($hSprite)
	If Not IsArray($hSprite) Then Return SetError(1, 0, 0)
	If UBound($hSprite) < $__GEng_SpritesArrayUB Then Return SetError(1, 0, 0)
	Return 1
EndFunc   ;==>__GEng_Sprite_IsSprite
Func __GEng_Sprite_ContainsImage($hSprite)
	If Not __GEng_Sprite_IsSprite($hSprite) Then Return SetError(1, 0, 0)
	If $hSprite[$_gSpr_iImg] = 0 Then Return SetError(1, 0, 0)
	Return 1
EndFunc   ;==>__GEng_Sprite_ContainsImage
Func __GEng_Sprite_InitArray(ByRef $a)
	For $i = 0 To $__GEng_SpritesArrayUB - 1
		$a[$i] = 0
	Next
	$a[$_gSpr_AnimDelayMulti] = 1
	$a[$_gSpr_hBuffer] = __GEng_GetBuffer()
	$a[$_gSpr_hImgAttrib] = _GDIPlus_ImageAttributesCreate()
	$a[$_gSpr_ColorMatrix] = _GDIPlus_ColorMatrixCreate()
	$a[$_gSpr_ColorMatrixPtr] = DllStructGetPtr($a[$_gSpr_ColorMatrix])
	_GDIPlus_ImageAttributesSetColorMatrix($a[$_gSpr_hImgAttrib], 0, True, $a[$_gSpr_ColorMatrixPtr])
EndFunc   ;==>__GEng_Sprite_InitArray
Func _GDIPlus_GraphicsDrawImageRectRectIA($hGraphics, $hImage, $nSrcX, $nSrcY, $nSrcWidth, $nSrcHeight, $nDstX, $nDstY, $nDstWidth, $nDstHeight, $hImageAttributes = 0, $iUnit = 2)
	Local $aResult = DllCall($__g_hGDIPDll, "int", "GdipDrawImageRectRect", "hwnd", $hGraphics, "hwnd", $hImage, "float", $nDstX, "float", $nDstY, "float", $nDstWidth, "float", $nDstHeight, "float", $nSrcX, "float", $nSrcY, "float", $nSrcWidth, "float", $nSrcHeight, "int", $iUnit, "hwnd", $hImageAttributes, "int", 0, "int", 0)
	If @error Then Return SetError(@error, @extended, False)
	Return $aResult[0] = 0
EndFunc   ;==>_GDIPlus_GraphicsDrawImageRectRectIA
Func _GEng_Sprite_AnimRewind(ByRef $hSprite, $iFrame = 1)
	If Not __GEng_Sprite_IsSprite($hSprite) Then Return SetError(1, 0, 0)
	$hSprite[$_gSpr_AnimFrame] = $iFrame
	$hSprite[$_gSpr_AnimTimer] = -1
	Return 1
EndFunc   ;==>_GEng_Sprite_AnimRewind
Func _GEng_Sprite_Animate(ByRef $hSprite, ByRef $hAnim, $iStopFrame = Default)
	If Not __GEng_Sprite_IsSprite($hSprite) Then Return SetError(1, 0, 0)
	If Not __GEng_Anim_IsAnim($hAnim) Then Return SetError(1, 0, 0)
	If _GEng_Anim_FrameCount($hAnim) = 0 Then Return SetError(1, 0, 0)
	Local $img
	If $hSprite[$_gSpr_AnimTimer] = -1 Then
		$img = __GEng_Anim_BuildImageFromFrame($hAnim, $hSprite[$_gSpr_AnimFrame])
		_GEng_Sprite_ImageSet($hSprite, $img, $hAnim[$hSprite[$_gSpr_AnimFrame]][1], $hAnim[$hSprite[$_gSpr_AnimFrame]][2], $hAnim[$hSprite[$_gSpr_AnimFrame]][3], $hAnim[$hSprite[$_gSpr_AnimFrame]][4])
		$hSprite[$_gSpr_AnimFrame] += 1
		$hSprite[$_gSpr_AnimTimer] = TimerInit()
	Else
		If TimerDiff($hSprite[$_gSpr_AnimTimer]) >= $hAnim[$hSprite[$_gSpr_AnimFrame]][5] Then
			$hSprite[$_gSpr_AnimFrame] += 1
			If $hSprite[$_gSpr_AnimFrame] > $hAnim[0][0] Then $hSprite[$_gSpr_AnimFrame] = 1
			$img = __GEng_Anim_BuildImageFromFrame($hAnim, $hSprite[$_gSpr_AnimFrame])
			_GEng_Sprite_ImageSet($hSprite, $img, $hAnim[$hSprite[$_gSpr_AnimFrame]][1], $hAnim[$hSprite[$_gSpr_AnimFrame]][2], $hAnim[$hSprite[$_gSpr_AnimFrame]][3], $hAnim[$hSprite[$_gSpr_AnimFrame]][4])
			$hSprite[$_gSpr_AnimTimer] = TimerInit()
		EndIf
		If $iStopFrame <> Default Then
			If $hSprite[$_gSpr_AnimFrame] = $iStopFrame Then Return -1
		EndIf
	EndIf
	Return 1
EndFunc   ;==>_GEng_Sprite_Animate
Func __GEng_Anim_BuildImageFromFrame(ByRef $hAnim, $iFrame)
	If Not __GEng_Anim_IsAnim($hAnim) Then Return SetError(1, 0, 0)
	If $iFrame > $hAnim[0][0] Then Return SetError(1, 0, 0)
	Local $ret[3]
	$ret[0] = $hAnim[$iFrame][0]
	$ret[1] = $hAnim[$iFrame][3]
	$ret[2] = $hAnim[$iFrame][4]
	Return $ret
EndFunc   ;==>__GEng_Anim_BuildImageFromFrame
Func _GEng_Sprite_Move(ByRef $hSprite)
	If Not __GEng_Sprite_IsSprite($hSprite) Then Return SetError(1, 0, 0)
	If Not $hSprite[$_gSpr_MoveTimer] Then
		$hSprite[$_gSpr_MoveTimer] = TimerInit()
		Return 0
	EndIf
	Local $ms = TimerDiff($hSprite[$_gSpr_MoveTimer]) / 1000
	If $hSprite[$_gSpr_AngleSpeedMax] <> 0 Then
		If Abs($hSprite[$_gSpr_AngleSpeed]) > Abs($hSprite[$_gSpr_AngleSpeedMax]) Then
			If $hSprite[$_gSpr_AngleSpeed] >= 0 Then
				$hSprite[$_gSpr_AngleSpeed] = Abs($hSprite[$_gSpr_AngleSpeedMax])
			Else
				$hSprite[$_gSpr_AngleSpeed] = -1 * Abs($hSprite[$_gSpr_AngleSpeedMax])
			EndIf
		EndIf
	EndIf
	Local $rotVit = $hSprite[$_gSpr_AngleSpeed]
	Local $rotAccel = $hSprite[$_gSpr_AngleAccel]
	Local $rotInner = $hSprite[$_gSpr_AngleInnertie]
	Local $currAngle = $hSprite[$_gSpr_AngleDeg]
	If $rotVit <> 0 Then
		_GEng_Sprite_AngleSet($hSprite, $currAngle + ($rotVit * $ms))
	EndIf
	If $rotAccel <> 0 Then
		$hSprite[$_gSpr_AngleSpeed] += $rotAccel * $ms
	EndIf
	Local $tmp
	If $rotInner <> 0 And $hSprite[$_gSpr_AngleSpeed] <> 0 Then
		$tmp = $hSprite[$_gSpr_AngleSpeed]
		If $hSprite[$_gSpr_AngleSpeed] > 0 Then
			$hSprite[$_gSpr_AngleSpeed] -= Abs($rotInner) * $ms
		ElseIf $hSprite[$_gSpr_AngleSpeed] < 0 Then
			$hSprite[$_gSpr_AngleSpeed] += Abs($rotInner) * $ms
		EndIf
		If $hSprite[$_gSpr_AngleSpeed] / $tmp < 0 Then $hSprite[$_gSpr_AngleSpeed] = 0
	EndIf
	Local $accelX = $hSprite[$_gSpr_AccelX], $accelY = $hSprite[$_gSpr_AccelY]
	Local $accelGrand = __GEng_VectorGrandeur($accelX, $accelY)
	$hSprite[$_gSpr_SpeedX] += $accelX * $ms
	$hSprite[$_gSpr_SpeedY] += $accelY * $ms
	Local $vitGrand = __GEng_VectorGrandeur($hSprite[$_gSpr_SpeedX], $hSprite[$_gSpr_SpeedY])
	Local $vitAngle = _GEng_VectorToAngle($hSprite[$_gSpr_SpeedX], $hSprite[$_gSpr_SpeedY])
	If $hSprite[$_gSpr_SpeedMax] <> 0 And $vitGrand > $hSprite[$_gSpr_SpeedMax] Then
		$tmp = _GEng_AngleToVector($vitAngle, $hSprite[$_gSpr_SpeedMax])
		$hSprite[$_gSpr_SpeedX] = $tmp[0]
		$hSprite[$_gSpr_SpeedY] = $tmp[1]
	EndIf
	If $hSprite[$_gSpr_SpeedX] <> 0 Then
		$hSprite[$_gSpr_PosX] += $hSprite[$_gSpr_SpeedX] * $ms
	EndIf
	If $hSprite[$_gSpr_SpeedY] <> 0 Then
		$hSprite[$_gSpr_PosY] += $hSprite[$_gSpr_SpeedY] * $ms
	EndIf
	Local $vect = _GEng_AngleToVector(_GEng_VectorToAngle($hSprite[$_gSpr_SpeedX], $hSprite[$_gSpr_SpeedY]), $hSprite[$_gSpr_Innertie])
	If $vect[0] <> 0 And $hSprite[$_gSpr_SpeedX] <> 0 And Not $accelX Then
		$tmp = $hSprite[$_gSpr_SpeedX]
		If $hSprite[$_gSpr_SpeedX] > 0 Then
			$hSprite[$_gSpr_SpeedX] -= Abs($vect[0]) * $ms
		ElseIf $hSprite[$_gSpr_SpeedX] < 0 Then
			$hSprite[$_gSpr_SpeedX] += Abs($vect[0]) * $ms
		EndIf
		If $hSprite[$_gSpr_SpeedX] / $tmp < 0 Then $hSprite[$_gSpr_SpeedX] = 0
	EndIf
	If $vect[1] <> 0 And $hSprite[$_gSpr_SpeedY] <> 0 And Not $accelY Then
		$tmp = $hSprite[$_gSpr_SpeedY]
		If $hSprite[$_gSpr_SpeedY] > 0 Then
			$hSprite[$_gSpr_SpeedY] -= Abs($vect[1]) * $ms
		ElseIf $hSprite[$_gSpr_SpeedY] < 0 Then
			$hSprite[$_gSpr_SpeedY] += Abs($vect[1]) * $ms
		EndIf
		If $hSprite[$_gSpr_SpeedY] / $tmp < 0 Then $hSprite[$_gSpr_SpeedY] = 0
	EndIf
	$hSprite[$_gSpr_MoveTimer] = TimerInit()
	Return 1
EndFunc   ;==>_GEng_Sprite_Move
Func __GEng_VectorGrandeur($x, $y)
	Return Abs(Sqrt(($x ^ 2) + ($y ^ 2)))
EndFunc   ;==>__GEng_VectorGrandeur
Func _GEng_Sprite_SizeSet(ByRef $hSprite, $w = Default, $h = Default)
	If Not __GEng_Sprite_IsSprite($hSprite) Then Return SetError(1, 0, 0)
	If $w <> Default Then
		If $w > 0 Then
			$hSprite[$_gSpr_Width] = $w
		Else
			$hSprite[$_gSpr_Width] = $hSprite[$_gSpr_ImgW]
		EndIf
	EndIf
	If $h <> Default Then
		If $h > 0 Then
			$hSprite[$_gSpr_Height] = $h
		Else
			$hSprite[$_gSpr_Height] = $hSprite[$_gSpr_ImgH]
		EndIf
	EndIf
	Return 1
EndFunc   ;==>_GEng_Sprite_SizeSet
Func _GEng_Sprite_AngleSet(ByRef $hSprite, $iAngle)
	If Not __GEng_Sprite_IsSprite($hSprite) Then Return SetError(1, 0, 0)
	$iAngle -= $hSprite[$_gSpr_AngleOriDeg]
	$iAngle = __GEng_GeometryReduceAngle($iAngle)
	$hSprite[$_gSpr_AngleDeg] = $iAngle
	$hSprite[$_gSpr_AngleRad] = __GEng_GeometryDeg2Rad($iAngle)
	Return 1
EndFunc   ;==>_GEng_Sprite_AngleSet
Func _GEng_Anim_Create()
	Local $a[1][6]
	$a[0][0] = 0
	Return $a
EndFunc   ;==>_GEng_Anim_Create
Func _GEng_Anim_FrameCount(ByRef $hAnim)
	If Not __GEng_Anim_IsAnim($hAnim) Then Return SetError(1, 0, 0)
	Return $hAnim[0][0]
EndFunc   ;==>_GEng_Anim_FrameCount
Func _GEng_Anim_FrameAdd(ByRef $hAnim, ByRef $hImage, $iFramDuration, $x = Default, $y = Default, $w = Default, $h = Default)
	If Not __GEng_Anim_IsAnim($hAnim) Then Return SetError(1, 0, 0)
	If Not __GEng_Image_IsImage($hImage) Then Return SetError(1, 0, 0)
	Local $uB = $hAnim[0][0]
	ReDim $hAnim[$uB + 2][6]
	$hAnim[$uB + 1][0] = $hImage[0]
	If $x <> Default And $y <> Default And $w <> Default And $h <> Default Then
		$hAnim[$uB + 1][1] = $x
		$hAnim[$uB + 1][2] = $y
		$hAnim[$uB + 1][3] = $w
		$hAnim[$uB + 1][4] = $h
	Else
		$hAnim[$uB + 1][1] = 0
		$hAnim[$uB + 1][2] = 0
		$hAnim[$uB + 1][3] = $hImage[1]
		$hAnim[$uB + 1][4] = $hImage[2]
	EndIf
	$hAnim[$uB + 1][5] = $iFramDuration
	$hAnim[0][0] += 1
	Return 1
EndFunc   ;==>_GEng_Anim_FrameAdd
Func __GEng_Anim_IsAnim(ByRef $hAnim)
	If UBound($hAnim, 2) <> 6 Then Return SetError(1, 0, 0)
	Return 1
EndFunc   ;==>__GEng_Anim_IsAnim
Func _GEng_ScrUpdatePNG()
	Local $gdibitmap = _GDIPlus_BitmapCreateHBITMAPFromBitmap($__GEng_hBitmap)
	Local $hOld = _WinAPI_SelectObject($__GEng_hCompatibleDC, $gdibitmap)
	Local $tSize = DllStructCreate($tagSIZE)
	Local $pSize = DllStructGetPtr($tSize)
	DllStructSetData($tSize, "X", 70)
	DllStructSetData($tSize, "Y", 70)
	Local $tSource = DllStructCreate($tagPOINT)
	Local $pSource = DllStructGetPtr($tSource)
	Local $tBlend = DllStructCreate($tagBLENDFUNCTION)
	Local $pBlend = DllStructGetPtr($tBlend)
	DllStructSetData($tBlend, "Alpha", 255)
	DllStructSetData($tBlend, "Format", 1)
	_GDIPlus_GraphicsClear($__GEng_hBuffer, 0)
	_WinAPI_UpdateLayeredWindow($__GEng_hGui, $__GEng_hDC, 0, $pSize, $__GEng_hCompatibleDC, $pSource, 0, $pBlend, 2)
	_WinAPI_ReleaseDC($__GEng_hGui, $__GEng_hDC)
	_WinAPI_SelectObject($__GEng_hCompatibleDC, $hOld)
	_WinAPI_DeleteObject($gdibitmap)
EndFunc   ;==>_GEng_ScrUpdatePNG
Func _GEng_AngleToVector($iAngle, $iGrandeur = 1)
	$iAngle = __GEng_GeometryDeg2Rad(__GEng_GeometryReduceAngle($iAngle))
	Local $ret[2] = [Cos($iAngle) * $iGrandeur, Sin($iAngle) * $iGrandeur]
	Return $ret
EndFunc   ;==>_GEng_AngleToVector
Func _GEng_VectorToAngle($difX, $difY)
	If $difX = 0 And $difY = 0 Then Return 0
	Local $tmp = Abs(ATan($difY / $difX))
	If $difX < 0 Then $tmp = $__GEng_PI - $tmp
	If $difY < 0 Then $tmp = $__GEng_PI + ($__GEng_PI - $tmp)
	Return __GEng_GeometryRad2Deg($tmp)
EndFunc   ;==>_GEng_VectorToAngle
Func __GEng_GeometryRad2Deg($rad)
	Local $ret = $rad / ($__GEng_PI / 180)
	Return __GEng_GeometryReduceAngle($ret)
EndFunc   ;==>__GEng_GeometryRad2Deg
Func __GEng_GeometryDeg2Rad($nDegrees)
	If $nDegrees >= 360 Then $nDegrees = __GEng_GeometryReduceAngle($nDegrees)
	Return $nDegrees / 57.2957795130823
EndFunc   ;==>__GEng_GeometryDeg2Rad
Func __GEng_GeometryReduceAngle($iAngle)
	$iAngle = Round($iAngle)
	If $iAngle < 0 Then
		$iAngle = 360 - (Abs($iAngle) - 360)
	EndIf
	While $iAngle >= 360
		$iAngle -= 360
	WEnd
	If $iAngle = 360 Then $iAngle = 0
	Return $iAngle
EndFunc   ;==>__GEng_GeometryReduceAngle
